import type { PeerId } from "@libp2p/interface-peer-id";
import { Bound } from "@canvas-js/okra";
import { AbstractGossipLog, GossipLogInit, ReadOnlyTransaction, ReadWriteTransaction } from "../AbstractGossipLog.js";
export declare class GossipLog<Payload, Result> extends AbstractGossipLog<Payload, Result> {
    private readonly db;
    private readonly messages;
    private readonly parents;
    static open<Payload, Result>(name: string, init: GossipLogInit<Payload, Result>): Promise<GossipLog<Payload, Result>>;
    private readonly incomingSyncPeers;
    private readonly outgoingSyncPeers;
    private readonly controller;
    private readonly lockName;
    private constructor();
    close(): Promise<void>;
    entries(lowerBound?: Bound<Uint8Array> | null, upperBound?: Bound<Uint8Array> | null, options?: {
        reverse?: boolean;
    }): AsyncIterable<[key: Uint8Array, value: Uint8Array]>;
    read<T>(callback: (txn: ReadOnlyTransaction) => Promise<T>, options?: {
        target?: PeerId;
    }): Promise<T>;
    write<T>(callback: (txn: ReadWriteTransaction) => Promise<T>, options?: {
        source?: PeerId;
    }): Promise<T>;
}
